<?php
require_once "./productTools.php";
require_once "./validate.php";

$postTarget = htmlspecialchars($_SERVER['PHP_SELF']);

if($_SERVER["REQUEST_METHOD"] == "POST"){
    $product;
    $errors = [];

    // CLEAN ALL FIELDS FROM ANY BAD DATA
    foreach($_POST as $key => $value){
        $product[$key] = cleanData($value);
    }
    
    // VALIDATE ID    
    if(!validID($product['id'])){
        $errors['id'] = "Invalid ID";
    }else if(!uniqueID($product['id'])){
        $errors['id'] = "ID is not unique";
    }

    // TODO: COMPLETE VALIDATION OF ADDITIONAL FIELDS

    // IF THERE ARE NO ERRORS, ADD THE RECORD
    if(empty($errors)){
        addProduct($product);
    }
}

?>

<html>
<head>
<title>Add Products</title>
<link type="text/css" rel="stylesheet" href="./style.css">
</head>
<body>

<ul class="navbar">
<li><a href="./add.php">Add Products</a></li>
<li><a href="./remove.php">Remove Products</a></li>
</ul>

<h1>Add Products</h1>

<form method="post" action="<?= $postTarget ?>">
<label for="id">ID</label><br>
<input type="text" name="id" placeholder="XXXX-XXXX (0-F)"
       value="<?= $product['id'] ?>" required> <?= $errors['id'] ?> <br> 

<!-- TODO: ADD ADDITIONAL FIELDS -->

<input type="submit">
</form>

<div>
<?php

// GET PRODUCTS AND GENERATE HTML
$products = getProducts();
foreach($products as $p){
    echo "<div class='product'>";
    foreach($p as $key => $value){
        echo "$key: $value<br>";
    }
    echo "</div>";
}

?>
</div>

</body>
</html>
